/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.cache;

import java.io.Serializable;

import org.tranql.field.FieldTransformException;
import org.tranql.field.Row;
import org.tranql.field.FieldTransform;

/**
 * 
 * 
 * @version $Revision: 62 $ $Date: 2004-04-23 04:05:26 -0400 (Fri, 23 Apr 2004) $
 */
public final class EmptySlotLoader implements Serializable {
    private final int slot;
    private final FieldTransform accessor;

    public EmptySlotLoader(int slot, FieldTransform accessor) {
        this.slot = slot;
        this.accessor = accessor;
    }

    public void set(CacheRow row, Row source) throws FieldTransformException {
        if (!row.isLoaded(slot)) {
            row.set(slot, accessor.get(source));
        }
    }

    public void setNull(CacheRow row) {
        if (!row.isLoaded(slot)) {
            row.set(slot, null);
        }
    }
}
