/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.cache;

import org.tranql.field.FieldTransform;
import org.tranql.field.Row;
import org.tranql.field.FieldTransformException;

/**
 *
 *
 *
 * @version $Revision: 45 $ $Date: 2004-04-19 18:23:20 -0400 (Mon, 19 Apr 2004) $
 */
public class ModifiedSlotDetector implements FieldTransform {
    private final int slot;

    public ModifiedSlotDetector(int slot) {
        this.slot = slot;
    }

    public Class getFieldClass() {
        return Boolean.TYPE;
    }

    public Object get(Row row) throws FieldTransformException {
        return Boolean.valueOf(((CacheRow)row).isModified(slot));
    }

    public void set(Row row, Object value) throws FieldTransformException {
        throw new UnsupportedOperationException("Set called for slot " + slot);
    }
}
