/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.cache;

import org.tranql.field.FieldTransform;
import org.tranql.field.Row;
import org.tranql.field.FieldTransformException;

/**
 *
 *
 *
 * @version $Revision: 173 $ $Date: 2005-02-20 10:42:56 -0500 (Sun, 20 Feb 2005) $
 */
public class NotNullAccessor implements FieldTransform {
    private final FieldTransform nullTester;
    private final FieldTransform next;
    
    public NotNullAccessor(FieldTransform nullTester, FieldTransform next) {
        this.nullTester = nullTester;
        this.next = next;
    }

    public Class getFieldClass() {
        return next.getFieldClass();
    }

    public Object get(Row row) throws FieldTransformException {
        if (null == nullTester.get(row)) {
            return null;
        }
        
        return next.get(row);
    }

    public void set(Row row, Object value) throws FieldTransformException {
        throw new UnsupportedOperationException();
    }
}
