/**
 *
 *  Copyright 2005 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ddl;

import org.tranql.schema.Entity;

/**
 *
 * @version $Revision: 246 $ $Date: 2005-08-26 22:09:42 -0400 (Fri, 26 Aug 2005) $
 */
public class Alter extends TableDDL {
    public static final AlterType ADD_COLUMN = new AlterType("ADD_COLUMN");
    public static final AlterType ADD = new AlterType("ADD");

    private static class AlterType {
        private final String name;
        
        private AlterType(String name) {
            this.name = name;
        }
        
        public String toString() {
            return name;
        }
    }
    
    private final AlterType type;
    
    public Alter(AlterType type, Entity entity) {
        super(entity);
        this.type = type;
    }

    public AlterType getType() {
        return type;
    }
    
    public Object visit(DDLVisitor visitor, Object param) throws DDLException {
        return visitor.visit(this, param);
    }
}
