/**
 *  Copyright 2006 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.dynamicquery;

import org.tranql.cache.GlobalSchema;
import org.tranql.ejb.EJBSchema;
import org.tranql.sql.EJBQLQueryToSQLCommandCompiler;
import org.tranql.sql.EJBQLToPhysicalQuery;
import org.tranql.sql.SQLSchema;

/**
 * 
 * @version $Revision: 327 $ $Date: 2006-03-02 06:04:50 -0500 (Thu, 02 Mar 2006) $
 */
public class BasicQueryManager implements QueryManager {
    private final EJBSchema ejbSchema;
    private final SQLSchema sqlSchema;
    private final GlobalSchema globalSchema;
    
    public BasicQueryManager(EJBSchema ejbSchema, SQLSchema sqlSchema, GlobalSchema globalSchema) {
        this.ejbSchema = ejbSchema;
        this.sqlSchema = sqlSchema;
        this.globalSchema = globalSchema;
    }

    public Query createQuery(String ejbql, Class[] types) {
        EJBQLQueryToSQLCommandCompiler queryBuilder = new EJBQLToPhysicalQuery(ejbSchema, sqlSchema, globalSchema);
        return new BasicQuery(queryBuilder, ejbql, types);
    }
}
