/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ejb;

import org.tranql.schema.Attribute;

/**
 *
 *
 * @version $Revision: 186 $ $Date: 2005-06-22 07:22:41 -0400 (Wed, 22 Jun 2005) $
 */
public class CMPField implements Attribute {
    private final String name;
    private final String physicalName;
    private final Class type;
    private final boolean identity;

    private String prefetchGroup;
    
    public CMPField(String name, Class type, boolean pkField) {
        this.name = name;
        this.physicalName = name;
        this.type = type;
        this.identity = pkField;
    }

    public CMPField(String name, String physicalName, Class type, boolean pkField) {
        this.name = name;
        this.physicalName = physicalName;
        this.type = type;
        this.identity = pkField;
    }

    public String getName() {
        return name;
    }

    public String getPhysicalName() {
        return physicalName;
    }

    public Class getType() {
        return type;
    }

    public boolean isIdentity() {
        return identity;
    }
    
    public void setPrefetchGroup(String prefetchGroup) {
        this.prefetchGroup = prefetchGroup;
    }
    
    public String getPrefetchGroup() {
        return prefetchGroup;
    }
    
    public String toString() {
        return "CMPField [" + name + "]; Physical name [" + physicalName + "]";
    }
}
