/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ejb;

import org.tranql.abstractschema.AbstractAssociationEnd;

/**
 *
 *
 * @version $Revision: 340 $ $Date: 2006-06-03 18:13:16 -0400 (Sat, 03 Jun 2006) $
 */
public class CMRField extends AbstractAssociationEnd {
    private String prefetchGroup;
    
    public CMRField(String name, EJB ejb, boolean isSingle, boolean isCascadeDelete, Relationship relationship, boolean isVirtual, boolean isOnPKSide) {
        super(name, ejb, isSingle, isCascadeDelete, relationship, isVirtual, isOnPKSide);
        relationship.addAssociationEnd(this);
    }

    public void setPrefetchGroup(String prefetchGroup) {
        this.prefetchGroup = prefetchGroup;
    }
    
    public String getPrefetchGroup() {
        return prefetchGroup;
    }


    public String toString() {
        return "CMRField [" + getName() + "]";
    }
}
