/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ejb;

import org.tranql.cache.CacheRow;
import org.tranql.cache.CacheRowState;
import org.tranql.cache.InTxCache;

/**
 *
 *
 *
 * @version $Revision: 10 $ $Date: 2004-03-16 14:08:46 -0500 (Tue, 16 Mar 2004) $
 */
public class PKFieldAccessCheck implements CMPFieldTransform {
    private final CMPFieldTransform next;

    public PKFieldAccessCheck(CMPFieldTransform next) {
        this.next = next;
    }

    public Object get(InTxCache cache, CacheRow row) {
        return next.get(cache, row);
    }

    public void set(InTxCache cache, CacheRow row, Object value) {
        if (row.getState() != CacheRowState.UNDER_CONSTRUCTION) {
            throw new IllegalStateException("Cannot set key field outside ejbCreate<METHOD>");
        }
        next.set(cache, row, value);
    }
}
