/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ejb;

import org.tranql.identity.IdentityTransform;
import org.tranql.identity.GlobalIdentity;
import org.tranql.identity.IdentityTransformException;
import org.tranql.cache.CacheTable;

/**
 *
 *
 *
 * @version $Revision: 20 $ $Date: 2004-03-20 09:21:51 -0500 (Sat, 20 Mar 2004) $
 */
public class SimplePKTransform implements IdentityTransform {
    private final CacheTable table;

    public SimplePKTransform(CacheTable table) {
        this.table = table;
    }

    public GlobalIdentity getGlobalIdentity(Object domainId) throws IdentityTransformException {
        return new GlobalIdentity(table, domainId);
    }

    public Object getDomainIdentity(GlobalIdentity globalId) throws IdentityTransformException {
        return globalId.getId();
    }
}
