// $ANTLR 2.7.4: "ejbql21.g" -> "EJBQL21Parser.java"$

/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ejb.parser;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public interface EJBQLTokenTypes {
	int EOF = 1;
	int NULL_TREE_LOOKAHEAD = 3;
	int EJBQL = 4;
	int RANGE_VARIABLE = 5;
	int COLLECTION_MEMBER = 6;
	int ABSTRACT_SCHEMA_NAME = 7;
	int PATH = 8;
	int FROM = 9;
	int COMMA = 10;
	int IN = 11;
	int LPAREN = 12;
	int AS = 13;
	int IDENTIFIER = 14;
	int RPAREN = 15;
	int SELECT = 16;
	int DISTINCT = 17;
	int OBJECT = 18;
	int AVG = 19;
	int MIN = 20;
	int MAX = 21;
	int SUM = 22;
	int COUNT = 23;
	int ORDER = 24;
	int BY = 25;
	int ASC = 26;
	int DESC = 27;
	int WHERE = 28;
	int OR = 29;
	int AND = 30;
	int NOT = 31;
	int EQ = 32;
	int NE = 33;
	int LT = 34;
	int LE = 35;
	int GT = 36;
	int GE = 37;
	int PLUS = 38;
	int MINUS = 39;
	int MULT = 40;
	int DIV = 41;
	int BETWEEN = 42;
	int INPUT_PARAM = 43;
	int LIKE = 44;
	int STRING_LITERAL = 45;
	int ESCAPE = 46;
	int IS = 47;
	int EMPTY = 48;
	int NULL = 49;
	int MEMBER = 50;
	int OF = 51;
	int DOT = 52;
	int CONCAT = 53;
	int SUBSTRING = 54;
	int LENGTH = 55;
	int LOCATE = 56;
	int ABS = 57;
	int SQRT = 58;
	int MOD = 59;
	int INTEGER_LITERAL = 60;
	int FLOAT_LITERAL = 61;
	int TRUE = 62;
	int FALSE = 63;
	int EXPLICIT_BRACKETING = 64;
	int UNARY_PLUS = 65;
	int UNARY_MINUS = 66;
	int UNKNOWN = 67;
	int WS = 68;
	int QUESTION = 69;
	int DIGIT = 70;
	int OCTAL_DIGIT = 71;
	int HEX_DIGIT = 72;
	int INTEGER_SUFFIX = 73;
	int FLOAT_SUFFIX = 74;
	int EXPONENT = 75;
}
