/**
 *
 *  Copyright 2005 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ejbqlcompiler;

import org.tranql.ql.QueryException;
import org.tranql.ql.RowConstructor;
import org.tranql.ql.Where;

/**
 * This visitor injects brackets around the where conditional expression.
 * 
 * @version $Revision: 183 $ $Date: 2005-03-11 20:25:48 -0500 (Fri, 11 Mar 2005) $
 */
class WhereBracketAppender extends InterRepresentationTransformer {

    public WhereBracketAppender() {
        super(null);
    }

    public Object visit(Where node, Object param) throws QueryException {
        Where to = new Where();
        RowConstructor rowConstructor = new RowConstructor();
        to.addChild(rowConstructor);
        visitChildren(rowConstructor, node, param);
        return to;
    }   
    
}
