/**
 *
 *  Copyright 2005 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ql;

import java.util.HashMap;
import java.util.Map;


/**
 *
 * @version $Revision: 186 $ $Date: 2005-06-22 07:22:41 -0400 (Wed, 22 Jun 2005) $
 */
public class QuerySourceDictionary  {
	private static final String ALIAS_PREFIX = "T";
	
    private final Map querySources = new HashMap();
    private int aliasIndex = 0;

    public QuerySource retrieveQuerySource(String alias) {
        return (QuerySource) querySources.get(alias);
    }

    public void registerQuerySource(QuerySource querySource) {
        querySources.put(querySource.getAlias(), querySource);
    }

    public String getNextAlias() {
        return ALIAS_PREFIX + aliasIndex++;
    }
}
