/**
 *
 *  Copyright 2004 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.ql;



/**
 *
 *
 * @version $Revision: 410 $ $Date: 2006-10-21 20:15:17 -0400 (Sat, 21 Oct 2006) $
 */
public interface QueryVisitor {
    public Object visit(Query node, Object param) throws QueryException;

    public Object visit(Insert node, Object param) throws QueryException;

    public Object visit(Update node, Object param) throws QueryException;

    public Object visit(SetList node, Object param) throws QueryException;

    public Object visit(Assignment node, Object param) throws QueryException;

    public Object visit(ConditionalAssignment node, Object param) throws QueryException;

    public Object visit(Delete node, Object param) throws QueryException;

    public Object visit(Select node, Object param) throws QueryException;

    public Object visit(From node, Object param) throws QueryException;

    public Object visit(Where node, Object param) throws QueryException;
    
    public Object visit(OrderBy node, Object param) throws QueryException;

    public Object visit(QuerySource node, Object param) throws QueryException;

    public Object visit(DerivedTable node, Object param) throws QueryException;

    public Object visit(Join node, Object param) throws QueryException;

    public Object visit(Path node, Object param) throws QueryException;

    public Object visit(EntityReference node, Object param) throws QueryException;

    public Object visit(AttributeReference node, Object param) throws QueryException;

    public Object visit(FKAttributeReference node, Object param) throws QueryException;

    public Object visit(TableConstructor node, Object param) throws QueryException;

    public Object visit(RowConstructor node, Object param) throws QueryException;

    public Object visit(Function node, Object param) throws QueryException;

    public Object visit(AggregateFunction node, Object param) throws QueryException;

    public Object visit(CountAggregateFunction node, Object param) throws QueryException;

    public Object visit(BinaryOperation node, Object param) throws QueryException;

    public Object visit(Not node, Object param) throws QueryException;

    public Object visit(Between node, Object param) throws QueryException;

    public Object visit(In node, Object param) throws QueryException;

    public Object visit(Like node, Object param) throws QueryException;

    public Object visit(Empty node, Object param) throws QueryException;

    public Object visit(Exists node, Object param) throws QueryException;
    
    public Object visit(IsNull node, Object param) throws QueryException;

    public Object visit(MemberOf node, Object param) throws QueryException;

    public Object visit(SubQuery node, Object param) throws QueryException;

    public Object visit(SubQuerySource node, Object param) throws QueryException;

    public Object visit(StringLiteral node, Object param) throws QueryException;

    public Object visit(NumericLiteral node, Object param) throws QueryException;

    public Object visit(BooleanLiteral node, Object param) throws QueryException;

    public Object visit(ParameterReference node, Object param) throws QueryException;
    
    public Object visit(UnaryOperator node, Object param) throws QueryException;
}
