/**
 *  Copyright 2006 Jeremy Boynes
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.sql;

import java.io.Serializable;

import org.tranql.ql.QueryException;
import org.tranql.query.UpdateCommand;

public interface UpdateCommandBuilder extends Serializable {
    UpdateCommand buildCreate() throws QueryException;
    
    UpdateCommand buildStore() throws QueryException;
    
    UpdateCommand buildRemove() throws QueryException;
}
