/**
 *
 *  Copyright 2005 Matt Hogstrom
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package org.tranql.sql.oracle;

import javax.sql.DataSource;

import org.tranql.ql.ConditionalAssignment;
import org.tranql.ql.Function;
import org.tranql.ql.Join;
import org.tranql.ql.Node;
import org.tranql.ql.QueryException;
import org.tranql.sql.sql92.SQL92Generator;
import org.tranql.sql.sql92.SQL92Generator.Context;


/**
 * @version $Revision: 286 $ $Date: 2005-10-26 15:43:27 -0400 (Wed, 26 Oct 2005) $
 */
public class OracleGenerator extends SQL92Generator {

    public OracleGenerator(DataSource ds) {
        super(ds);
    }

    public Object visit(ConditionalAssignment node, Object param) throws QueryException {
        Context ctx = (Context) param;
        Node set = node.getChild();
        Node flag = set.getSibling();
        Node value = flag.getSibling();
        set.visit(this, param);
        ctx.append(" = CASE WHEN 1 = ");
        flag.visit(this, param);
        ctx.append(" THEN ");
        value.visit(this, param);
        ctx.append(" ELSE ");
        set.visit(this, param);
        ctx.append(" END");
        return param;
    }
}
