/**
 * 
 */
package org.tranql.sql.prefetch;

import java.util.HashSet;

import org.tranql.cache.CacheRow;
import org.tranql.field.FieldTransform;
import org.tranql.field.FieldTransformException;
import org.tranql.identity.GlobalIdentity;
import org.tranql.sql.prefetch.PrefetchGroupHandler.BooleanHolder;
import org.tranql.sql.prefetch.PrefetchGroupHandler.CacheContext;

class MultiValueAccessor implements ParentAccessor {
    private final FieldTransform accessor;
    
    public MultiValueAccessor(FieldTransform accessor) {
        this.accessor = accessor;
    }
    
    public void addGlobalIdentity(CacheContext ctx, CacheRow row, GlobalIdentity id) throws FieldTransformException {
        Object value = accessor.get(row);
        if (value == CacheRow.NO_DATA) {
            value = new HashSetMarker(ctx.inConstruction);
            accessor.set(row, value);
        }
        if (value instanceof MultiValueAccessor.HashSetMarker) {
            MultiValueAccessor.HashSetMarker marker = (MultiValueAccessor.HashSetMarker) value;
            if (marker.inConstruction.bool) {
                marker.add(id);
            }
        }
    }
    
    static class HashSetMarker extends HashSet {
        final BooleanHolder inConstruction;
        private HashSetMarker(BooleanHolder bool) {
            this.inConstruction = bool;
        }
    }
}