/**
 * 
 */
package org.tranql.sql.prefetch;

import org.tranql.cache.CacheRow;
import org.tranql.field.FieldTransform;
import org.tranql.field.FieldTransformException;
import org.tranql.identity.GlobalIdentity;
import org.tranql.sql.prefetch.PrefetchGroupHandler.CacheContext;

class SingleValueAccessor implements ParentAccessor {
    private final FieldTransform accessor;
    
    public SingleValueAccessor(FieldTransform accessor) {
        this.accessor = accessor;
    }
    
    public void addGlobalIdentity(CacheContext ctx, CacheRow row, GlobalIdentity id) throws FieldTransformException {
        Object value = accessor.get(row);
        if (value == CacheRow.NO_DATA) {
            accessor.set(row, id);
        }
    }
}